part of viltage;

class Entity {
  int layer;
  Display display;
  Sprite _sprite;
  List<State> states = new List<State>();
  
  Entity(this._x, this._y, this.layer, this.display) {
    states.add(new State(this));
    _sprite = states[_activeState]._sprite;
    
    setPosition(_sprite);
    
    display._sprites[layer].addChild(_sprite);
  }
  
  setPosition(Sprite s) {
    s.x = x*display.viltage.config.boxWidth;
    s.y = y*display.viltage.config.boxHeight;
  }

  remove() {
    display._sprites[layer].removeChild(_sprite);
  }
  
  int get activeState => _activeState; int _activeState = 0;
  
  set activeState(int newActiveState) {
    display._sprites[layer].removeChild(_sprite);
    
    _activeState = newActiveState;
    _sprite = states[_activeState]._sprite;
    
    display._sprites[layer].addChild(_sprite);

    setPosition(_sprite);
  }
  
  int get x => _x; int _x;
  int get y => _y; int _y;
  
  set x(int x) {
    _x = x;
    setPosition(_sprite);
  }
  
  set y(int y) {
    _y = y;
    setPosition(_sprite);
  }
}