library viltage;
import 'dart:html';
import 'dart:html' as HTML;
import 'package:stagexl/stagexl.dart';
import 'dart:async';

part 'viltage_config.dart';
part 'input.dart';
part 'display.dart';
part 'entity.dart';
part 'state.dart';
part 'char_node.dart';

class VilTAGE {
  VilTAGEConfig config;
  Input input;
  RenderLoop renderLoop;
  
  /* streams */
  StreamController _controllerUpdate = new StreamController();
  Stream onUpdate;
  
  VilTAGE(VilTAGEConfig config) {
    this.config = config;
    input = new Input();
    renderLoop = new RenderLoop();

    display = new Display(this);
    
    onUpdate = _controllerUpdate.stream;
    renderLoop.addStage(display);
  }
  
  Display display;
  
  setDisplay(Display newScreen) {
    renderLoop.removeStage(display);
    renderLoop.addStage(newScreen);
    display = newScreen;
    display.focus = display;
  }
  
  update(num fps) {
    input.update();
    _controllerUpdate.add(fps);
  }
}